//32

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, MMSystem, zasobnik;


type
  TForm1 = class(TForm)
    image: TImage;
    buffer: TImage;
    btnLoadMap: TButton;
    OpenDialog: TOpenDialog;
    findPath: TButton;
    Memo1: TMemo;
    btnLoadPath: TButton;
    ScrollBar1: TScrollBar;
    Button2: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure btnLoadMapClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure findPathClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure btnLoadPathClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    mapa : TMapa;
    map_width, map_height: integer;
    cil1, cil2: TPoint;
    start_x, start_y: integer;
    nacteno, nacteno_trasa : boolean;

    trasa : array[0..1000] of TPoint;

    function PntInRect(x,y: integer): boolean;
    function MapPntInRect(x,y: integer): boolean;
  public
    { Public declarations }
    function NacistMapu(jmeno: string): boolean;
    function NacistTrasu(jmeno: string): boolean;
    procedure Vykreslit;
    procedure NajitCestu;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function MapChrToInt(c: char): integer;
begin
  case c of
    'X','x': Result := 0;
    'S','s': Result := 1;
    'C','c': Result := 2;
    '.': Result := 4;
    ':': Result := 8;
  else
    Result := -1;
  end;
end;

function MapIntToColor(i: integer): TColor;
begin
  case i of
    1: Result := clBlue;
    2: Result := clFuchsia;
    4: Result := clGreen;
    8: Result := clLime;
  else
    Result := clBlack;
  end;
end;

function TForm1.NacistMapu(jmeno: string): boolean;
var soubor : TStringList;
    i, j, delka, pocet_s: integer;
    str: string;
    warn: boolean;
begin
  Result := false;
  if not FileExists(jmeno) then
    begin
      MessageDlg ('Soubor nenalezen!', mtError, [mbOK], -1);
      exit;
    end;

  try
    soubor := TStringList.Create();
    soubor.LoadFromFile(jmeno);
    if soubor.Count > MAX_SIZE then
      begin
        MessageDlg ('Poet dk v souboru je vt jak ' + IntToStr(MAX_SIZE), mtError, [mbOK], -1);
        exit;
      end;
    if soubor.Count < 1 then
      begin
        MessageDlg ('Soubor neobsahuje dn dek', mtError, [mbOK], -1);
        exit;
      end;
    map_height := soubor.Count;

    map_width := Length(soubor[0]);
    for i := 1 to soubor.Count - 1 do
      begin
        if Length(soubor[0]) <> map_width then
          begin
            MessageDlg ('Chyba formtu souboru:'#13#10'Soubor nem jednotnou dlku dk',
                mtError, [mbOK], -1);
            exit;
          end;
      end;

    cil1 := Point(-1, -1);
    cil2 := Point(-1, -1);

    pocet_s := 0;
    warn := false;
    for j := 0 to map_height - 1 do
      begin
        str := soubor[j];
        for i := 0 to map_width-1  do
          begin
            mapa[i, j] := MapChrToInt(str[i+1]);

            if (mapa[i,j] = ID_JINY) and (not warn) then
              begin
                MessageDlg ('V souboru mapy byl nalezen neznm znak'
                        + #13#10 + 'tento znak bude povazovan za necestu',
                        mtError, [mbOK], -1);
                mapa[i,j] := ID_MIMO_CESTU;
                warn := true;
              end;

            case mapa[i,j] of
              ID_START:
                begin
                  inc(pocet_s);
                  start_x := i;
                  start_y := j;
                end;
              ID_CIL:
                begin
                  if cil1.X < 0 then
                    begin
                    cil1 := Point(i, j);
                    cil2 := Point(i, j);
                    end
                  else
                    if (cil2.X <= i) and (cil2.Y <= j) then
                      cil2 := Point(i, j);

                  if (cil1.X > i) then
                    cil2 := Point(MAX_SIZE + 1, MAX_SIZE + 1);
                end;
            end;
          end;
      end;

    for j := cil1.Y to cil2.Y do
      for i := cil1.X to cil2.X do
        begin
          if (mapa[i,j] <> ID_CIL) or (cil1.X < 0) or (cil2.X > MAX_SIZE) then
              begin
                MessageDlg ('V souboru mapy nen cl zadn jako souvisl obdlnk',
                        mtError, [mbOK], -1);
                exit;
              end;
        end;

    if pocet_s <> 1 then
      begin
        MessageDlg ('Start nen zadn v map sprvn', mtError, [mbOK], -1);
        exit;
      end;

    soubor.Clear;
    soubor.Free;
  except
    exit;
  end;

  Result := true;
end;

procedure TForm1.Vykreslit;
var w, h, x, y: integer;
begin
  if nacteno then
    try
      w := buffer.Width div map_width;
      h := buffer.Height div map_height;
    except
      h:= 1; w := 1;
    end;

  with buffer.Canvas do
    begin
      Brush.Color := clBlack;
      FillRect(Rect(0,0, buffer.Width, buffer.Height));
      if nacteno then
        for y := 0 to map_height do
          for x := 0 to map_width do
            begin
              Brush.Color := MapIntToColor(mapa[x,y]);
              FillRect(Rect(x*w, y*h, (x+1)*w, (y+1)*h));
            end;
      if nacteno_trasa then
        begin
          Brush.Color := clYellow;
          for x := 0 to ScrollBar1.Position do
             FillRect(Rect(trasa[x].X *w, trasa[x].y*h, (trasa[x].x+1)*w, (trasa[x].y+1)*h));
        end;
    end;

  image.Canvas.Draw(0,0,buffer.Picture.Bitmap);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  nacteno := false;
  nacteno_trasa := false;
  ScrollBar1.Min := 0;
  ScrollBar1.Max := 0;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  //Vykreslit;
end;

procedure TForm1.btnLoadMapClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    nacteno := NacistMapu(OpenDialog.FileName);
  Vykreslit;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Vykreslit;
end;


 (*
function Pohyb(x,y, mx, my: integer; str: string; limit: boolean = false): PPohyb;
begin
  Result := new(PPohyb);
  Result^.x := x;
  Result^.y := y;
  Result^.mx := mx;
  Result^.my := my;
  Result^.limit := limit;
  Result^.pohyb := str + IntToStr(mx) + ',' + IntToStr(my) + #13#10;
end;  *)

function TForm1.PntInRect(x,y: integer): boolean;
begin
  result := (x >= cil1.X) and (x <= cil2.X) and (y >= cil1.Y) and (y <= cil2.Y);
end;

procedure GetXY(var x, y: integer; i, w: integer);
begin
  x := i mod w;
  y := i div w;
end;

procedure TForm1.NajitCestu;

begin
  if not nacteno then exit;
  // Najdeme nejrychlej cestu... zatm hrubou silou - prohledvn do ky :/
  // tak nakonec ani to ne

  try
   { for j:= 0 to map_height*map_width-1 do
      begin
      for i:=0 to map_width*map_height-1 do
        begin
           GetXY(x1,y1,j,map_width);
           GetXY(x2,y2,i,map_width);
           if(sqr(x1-x2) + sqr(y1-y2) <= 2) and (mapa[x1,y1] and (ID_CESTA or ID_CESTA2) > 0)
           and (mapa[x2,y2] and (ID_CESTA or ID_CESTA2) > 0) then
             mapa2[i,j] := 1 else mapa2[i,j] := 0;
           a[i,j] := 0;
        end;
        B[j] := 0;
      end;}
{
    zas := TZasobnik.Create(start_x,start_y, @mapa, map_width, map_height);
    while zas.Count > 0 do
      begin
        pohyb := zas.Vyjmout();

        if PntInRect(pohyb^.x, pohyb^.y) then
          begin
            vysledek := pohyb^.pohyb;
            Dispose(pohyb);
            break;
          end;

        mapa[pohyb^.x, pohyb^.y] := ID_CESTA2;

        if not (pohyb^.limit and (pohyb^.mx = 5) and (pohyb^.my = 5)) then
          zas.Pridat(pohyb, 1, 1);
        if not (pohyb^.limit and (pohyb^.mx = -5)) then
          zas.Pridat(pohyb, -1, 0);
        if not (pohyb^.limit and (pohyb^.my = -5)) then
          zas.Pridat(pohyb, 0, -1);
        zas.Pridat(pohyb, 0, 0);
        if not (pohyb^.limit and (pohyb^.mx = -5) and (pohyb^.my = 5)) then
          zas.Pridat(pohyb, -1, 1);
        if not (pohyb^.limit and (pohyb^.my = 5)) then
          zas.Pridat(pohyb, 0, 1);
        if not (pohyb^.limit and (pohyb^.mx = 5) and (pohyb^.my = -5)) then
          zas.Pridat(pohyb, 1, -1);
        if not (pohyb^.limit and (pohyb^.mx = 5)) then
          zas.Pridat(pohyb, 1, 0);
        if not (pohyb^.limit and (pohyb^.mx = -5) and (pohyb^.my = -5)) then
          zas.Pridat(pohyb, -1, -1);


        Dispose(pohyb);
        if timeGetTime - cas > 60000 then break;
        if timeGetTime mod 1000 > 998 then
        begin
        Vykreslit; Application.ProcessMessages;
        end;
      end;

    zas.Clear;
    zas.Free;          }
    //Memo1.Text := vysledek;
  finally
  end;

end;

procedure TForm1.findPathClick(Sender: TObject);
begin
  if nacteno then
  NajitCestu;
end;

function TForm1.NacistTrasu(jmeno: string): boolean;
begin
  Memo1.Lines.LoadFromFile(jmeno);
  ScrollBar1.Min := 0;
  ScrollBar1.Max := Memo1.Lines.Count;
  ScrollBar1.Position := 0;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var i, x, y, p, vx, vy :integer;
  str, sx, sy: string;
begin
 if not nacteno_trasa then exit;
  trasa[0] := Point(start_x, start_y);
  vy := 0; vx := 0;
  for i := 1 to ScrollBar1.Position do
     begin
        str := Memo1.Lines[i-1];
        trasa[i] := trasa[i-1];
        if Pos(',', str) < 0 then continue;
        x := 1;
        sx := '';
        while str[x] <> ',' do
        begin
          if str[x] in ['0','1','-'] then sx := sx + str[x];
          inc(x);
        end;
        sy := '';
        while x <= Length(str) do
        begin
          if str[x] in ['0','1','-'] then sy := sy + str[x];
          inc(x);
        end;
        vx := vx + StrToInt(sx);
        vy := vy - StrToInt(sy);
        trasa[i] := Point(trasa[i-1].X+vx,trasa[i-1].Y+vy);
        if not MapPntInRect(trasa[i].X, trasa[i].Y) or
        (mapa[trasa[i].X, trasa[i].Y] = ID_MIMO_CESTU) then
        begin
          trasa[i] := trasa[i-1];
          vy := 0; vx := 0;
        end;
     end;
  Vykreslit;
end;

function TForm1.MapPntInRect(x,y: integer): boolean;
begin
  result := (x >= 0) and (x < map_width) and (y >= 0) and (y < map_height);
end;

procedure TForm1.btnLoadPathClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    nacteno_trasa := NacistTrasu(OpenDialog.FileName);
  //Vykreslit
  
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   ScrollBar1.Position := ScrollBar1.Position + 1;
   if  ScrollBar1.Position = ScrollBar1.Max then
     Timer1.Enabled := False;
end;

end.
